var BoneModel3D = function()
{
	this._bones = [];
	this._matrices = [];
	this._matrices2 = [];
	this._matrices3 = [];
	this._vertexBoneBuffer;
};
BoneModel3D.prototype = new Model3D();

BoneModel3D.prototype =
{
	init : function()
	{
		Model3D.prototype.init.call(this);
		this._bones = new Array();
		this._matrices = new Array();
		this._matrices2 = new Array();
		this._matrices3 = new Array();
	},
	setMaterial : function(r,g,b,a,dif,amb,emi,spc,power,texture)
	{
		this._materials.push(new Material(r,g,b,a,dif,amb,emi,spc,power,texture));
	},
	setVertex : function(x,y,z,nx,ny,nz,material,bone)
	{
		this._vertices.push(x,y,z);
		this._normals.push(nx,ny,nz);
		this._material.push(~~(material));
		this._bones.push(~~(bone));
	},
	setUV : function(u,v)
	{
		this._uvs.push(u,v);
	},
	getVerticesLength : function()
	{
		return ~~(this._vertices.length/3);
	},
	getColors : function()
	{
		return Model3D.prototype.getColors.call(this);
	},
	setMatrix : function(matrix)
	{
		for ( i = 0; i < 16; i++ )
		{
			this._matrices.push(matrix[i]);
		}
	},
	setMatrix2 : function()
	{
		this._matrices2.push(this._matrices);
		this._matrices = new Array();
	},
	setMatrix3 : function()
	{
		this._matrices3.push(this._matrices2);
		this._matrices2 = new Array();
	},
	initBuffers : function()
	{
		Model3D.prototype.initBuffers.call(this);

		this._vertexBoneBuffer = _gl.createBuffer();
		_gl.bindBuffer(_gl.ARRAY_BUFFER, this._vertexBoneBuffer);
		_gl.bufferData(_gl.ARRAY_BUFFER, new Float32Array(this._bones), _gl.STATIC_DRAW);
		this._vertexBoneBuffer.itemSize = 1;
		this._vertexBoneBuffer.numItems = this.getVerticesLength();
	},
	draw : function()
	{
		if ( !this._visible )
		{
			return;
		}

		mvPushMatrix();

		Model3D.prototype.setVertices.call(this);

		_gl.uniform1i(_shaderProgram.u_useBone, true);
		_gl.enableVertexAttribArray(_shaderProgram.a_bone);
		_gl.bindBuffer(_gl.ARRAY_BUFFER, this._vertexBoneBuffer);
		_gl.vertexAttribPointer(_shaderProgram.a_bone,this._vertexBoneBuffer.itemSize, _gl.FLOAT, false, 0, 0);

//		var matrix = [1,0,0,0,0,1,0,0,0,0,1,0,0,0,0,1,폜
//			1,0,0,0,0,1,0,0,0,0,1,0,100,100,0,1];폜
		_gl.uniformMatrix4fv(_shaderProgram.u_boneMatrix, false, this._matrices3[0][0]);

		_gl.drawArrays(_gl.TRIANGLES, 0, this.getVerticesLength() );

		mvPopMatrix();
	},
	addRotateY : function(delta)
	{
		Model3D.prototype.addRotateY.call(this,delta);
	},
	addRotateY2 : function(delta)
	{
		Model3D.prototype.addRotateY2.call(this,delta);
	},
};
